/**********************************/
/* Your Andrew login ID goes here */
/**********************************/
char andrewid[] = "";


/* 
 * tfgets-thread - timeout version of fgets based on 
 *                 threads, mutex, and condition variable.
 */ 
#include <ics.h>
#include <tfgets.h>

/* function prototypes */
void *thread(void *vargp);
struct timespec *maketimeout(struct timespec *tp, int secs);

/* fgets thread arguments */
struct args {
  char *s;
  int size;
  FILE *stream;
}; 

/* condition variable and its associated mutex */
pthread_cond_t cond;
pthread_mutex_t mutex;

/* timeout version of fgets */
char *tfgets(char *str, int size, FILE *stream) { 
  int rc;
  struct timespec timeout;
  pthread_t tid;
  struct args args = {str, size, stream};
  char **retval = &str;

  return NULL;
}

/* thread routine */
void *thread(void *vargp) {
  struct args *argp = vargp;
  return NULL;
}

/* 
 * Updates a timeout struct for pthread_cond_timedwait 
 * Example: to wait at most 1 second for condition cond:
 *    rc = pthread_cond_timedwait(&cond, &mutex, maketimeout(&timeout, 1));
 */
struct timespec *maketimeout(struct timespec *tp, int secs) {
  struct timeval now;
  gettimeofday(&now, NULL);
  tp->tv_sec = now.tv_sec + secs;
  tp->tv_nsec = now.tv_usec * 1000;
  return tp;
}

